#!/usr/bin/perl -w

use lib "..";
use HotSaNIC;
use RRDs;
#use DBI;

# get cmdline arguments (i.e. options passed by the daemon)
# and other global parameters
#
%ARGS=arg2opt(@ARGV);

dupe_control("start",$ARGS{"MODNAME"},"");

# read module-specific settings
#
open (FILE,"settings");
while (<FILE>) {
  ($var,$value)=parse_line($_);

  if ($var eq "IWCONFIG") {$IWCONFIG=$value;}
  if ($var eq "IFACE") {
     ($iface)=split(/,/,$value);
     push @IFACES,$iface;
     next;
  }
  if ($var eq "MAC") {
     ($iface,$mac)=split(/,/,$value);
     $ifmac= "$iface,$mac" ;
     push @IFMACS,$ifmac;
     next;
  }
}

close(FILE);

# print "@IFMACS \n";

foreach $iface (@IFACES) {
  
  if ( ! -e "rrd/$iface.rrd" ) { system("./makerrd","$iface", "U") }
  system("$IWCONFIG $iface > processed.$iface");
  open (FILE,"processed.$iface");
  while(<FILE>) {
      $var=$_;
    if ($var =~ /^.*Rate[=|:]+(.*)M.*/) {
      $rate=$1; 
    } elsif ($var =~ /^.*Quality:+(.*)\/.*:(.*)\sdBm.*:(.*)\sdBm.*/) {
      $quality=$1; 
      $signal=$2; 
      $noise=$3; 
      last;
    } elsif ($var =~ /^.*Mode[=|:]+(.*)  Fre.*/ ) {
      $mode=$1;
    }
  }
  close(FILE);
  $rate=$rate*10;

  if ($mode eq "Managed" ) {

  RRDs::update "rrd/$iface.rrd",time.":".$rate.":".$quality.":".$signal.":".$noise;
  if ($ERROR = RRDs::error) { dupe_control("warn",$ARGS{"MODNAME"},"unable to update `$iface.rrd': $ERROR"); }

  } 

  if ($mode eq "Master" ) {
    @clients = glob( "/proc/net/hostap/$iface/00*" );
    $clients = @clients;
    $clients = $clients*10;
    $signal=0; 
    $noise=0; 
#    print "/proc/net/hostap/$iface \n";
#    print "@IFMACS \n";
    @IFMACSNR=();
    foreach $ifmac (@IFMACS)
    {
      ($ifmaci,$ifmacm)=split(/,/,$ifmac);
      if ($ifmaci eq $iface ) {
    #    print "tohle >";
        # system("cat /proc/net/hostap/$iface/$mac > processed.$iface.$mac");
        $iwmsnr=0; 
        if ( -r "/proc/net/hostap/$ifmaci/$ifmacm" )
        {  
          open (FILE,"/proc/net/hostap/$ifmaci/$ifmacm");
          while(<FILE>)
          {
            $var=$_;
            if ($var =~ /^.*silence=+(.*)\ssignal=+(.*)\srate.*/)
            {
              $iwmsilence=$1; 
              $iwmsignal=$2; 
              $iwmsnr=$iwmsignal-$iwmsilence; 
#              print "silence=$iwmsilence snr=$iwmsnr ";
              last;
            } # if
          } # while 
          close(FILE);
        } # if
        push @IFMACSNR,$iwmsnr;
      } # if
    #  print "$ifmaci ma $ifmacm \n";  
    } # foreach
    if ($IFMACSNR[0] eq "") { $IFMACSNR[0]=0; }
    if ($IFMACSNR[1] eq "") { $IFMACSNR[1]=0; }
    #  print "@IFMACSNR ";

  RRDs::update "rrd/$iface.rrd",time.":".$rate.":".$clients.":".$IFMACSNR[0].":".$IFMACSNR[1];
  if ($ERROR = RRDs::error) { dupe_control("warn",$ARGS{"MODNAME"},"unable to update `$iface.rrd': $ERROR"); }

  } 

  
}
